function[chain] = AbsoluteChainNaive(ot)

[m,n] = size(ot);
out = false;
chain_index = 1;

[row,col] = hasZeros(ot);                % finding the index of the black pixel, that is the most left and up 
while (row ~= -1)
   ot(row,col) = 6;                    % mark this pixel as visited
   [dir,dx,dy] = findNext(ot,row,col);
   if dir ~= -1                         % if dir==-1 we are in a dead end, and look for new chain start.
       chain(chain_index) = dir;
       chain_index = chain_index + 1;
       row = row+dy;
       col = col+dx;      
   else
    [row,col] = hasZeros(ot);
   end;
end;
return;
    
function[row ,col] = hasZeros(ot)
[m,n] = size(ot);
for i = 1:m             
    for j = 1:n
        if ot(i,j) == 0
            row = i;
            col = j;
            return;
        end;
    end;
end;
row = -1;
col = -1;
return;
  
% findNext - using the absolute chain code, finding location of the next
% pixel containing zero.
% num = the direction number according to the absolute compass.
% dx = the change in the column coordinate.
% dy = the change in the row coordinate.
function [num, dx, dy] = findNext(ot, row, col)
dx=0;
dy=0;
if ot(row, col+1) == 0
    num = 0;
    dx = 1;
else
    if ot(row-1,col+1) == 0
        num = 1;
        dy = -1;
        dx = 1;
    else
        if ot(row-1,col) == 0
            num = 2;
            dy = -1;
        else
            if ot(row-1,col-1) == 0
                num = 3;
                dx = -1;
                dy = -1;
            else
                if ot(row, col-1) == 0
                    num = 4;
                    dx = -1;
                else
                    if ot(row+1,col-1) == 0
                        num = 5;
                        dx = -1;
                        dy = 1;
                    else
                        if ot(row+1,col) == 0
                            num = 6;
                            dy = 1;
                        else
                            if ot(row+1,col+1) == 0
                                num = 7;
                                dx = 1;
                                dy = 1;
                            else 
                                num = -1;
                                dx = -1;
                                dy = -1;
                            end;
                        end;
                    end;
                end;
            end;
        end;
    end;
end;
return;
